package com.ylx.web.controller.massage;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ylx.common.core.domain.R;
import com.ylx.common.utils.uuid.IdUtils;
import com.ylx.massage.domain.TTxRecord;
import com.ylx.massage.domain.TWxUser;
import com.ylx.massage.enums.TTxRecordEnum;
import com.ylx.massage.service.TTxRecordService;
import com.ylx.massage.service.TWxUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.List;

/**
 * 提现表 前端控制器
 */
@RestController
@RequestMapping("api/tx/record")
@Api(tags = {"提现记录"})
public class TTxRecordController {
    @Resource
    private TTxRecordService recordService;

    @Resource
    private TWxUserService wxUserService;

    /**
     * 添加申请记录
     *
     * @return
     */
    @ApiOperation("申请提现")
    @RequestMapping(value = "wx/addOrUpdate", method = RequestMethod.POST)
    public R addOrUpdate(@RequestBody TTxRecord record) {
        if (StringUtils.isBlank(record.getcId())) {
            record.setnStatus(TTxRecordEnum.PASS_ING.getCode());
            record.setDtCreateTime(LocalDateTime.now());
            UpdateWrapper<TWxUser> businessUpdateWrapper = new UpdateWrapper<>();
            businessUpdateWrapper.lambda().eq(TWxUser::getcOpenid, record.getcOpenId());
            businessUpdateWrapper.lambda().setSql(" d_balance = d_balance - " + record.getdPrice());
            wxUserService.update(businessUpdateWrapper);
        }
        return R.ok(recordService.saveOrUpdate(record));
    }

    /**
     * 管理员获取提现信息
     *
     * @return
     */
    @RequestMapping(value = "select", method = RequestMethod.GET)
    @ApiOperation("分页查询数据")
    public R<Page<TTxRecord>> select(Page<TTxRecord> page, TTxRecord txRecord) {
        // 获取页数
        LambdaQueryWrapper<TTxRecord> tTxRecordLambdaQueryWrapper = new LambdaQueryWrapper<>();
        tTxRecordLambdaQueryWrapper.eq(null != txRecord.getnStatus(), TTxRecord::getnStatus, txRecord.getnStatus()).
                orderByDesc(TTxRecord::getDtCreateTime);
        return R.ok(recordService.page(page, tTxRecordLambdaQueryWrapper));
    }


    /**
     * 商家获取提现记录
     *
     * @return
     */
    @ApiOperation("商家获取提现记录")
    @RequestMapping(value = "wx/select", method = RequestMethod.GET)
    public R<List<TTxRecord>> wxSelect(TTxRecord txRecord) {
        LambdaQueryWrapper<TTxRecord> tTxRecordLambdaQueryWrapper = new LambdaQueryWrapper<>();
        tTxRecordLambdaQueryWrapper.eq(null != txRecord.getcOpenId(), TTxRecord::getcOpenId, txRecord.getcOpenId()).
                orderByDesc(TTxRecord::getDtCreateTime);
        return R.ok(recordService.list(tTxRecordLambdaQueryWrapper));
    }
}
